<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2004 Ian Berry                                            |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | cacti: a php-based graphing solution                                    |
 +-------------------------------------------------------------------------+
 | Most of this code has been designed, written and is maintained by       |
 | Ian Berry. See about.php for specific developer credit. Any questions   |
 | or comments regarding this code should be directed to:                  |
 | - iberry@raxnet.net                                                     |
 +-------------------------------------------------------------------------+
 | - raXnet - http://www.raxnet.net/                                       |
 +-------------------------------------------------------------------------+

  __   __   __  ____  __  ___  ____  __  ___   __  __
 / _) (  ) / _)(_  _)(  )/ __)(_  _)/  \(  ,) (  )/ _)
( (_  /__\( (_   )(   )( \__ \  )( ( () ))  \  )(( (_
 \__)(_)(_)\__) (__) (__)(___/ (__) \__/(_)\_)(__)\__)
             - History feature for cacti -
======================================================


Developers:
----------

Droopy <cactistoric AT linkdown DOT org>
    Web: http://linkdown.org


See README file for licence detail.

This file is based on graph.php.

*/

$guest_account = true;
include("./include/auth.php");
include("./include/top_graph_header.php");


/* make sure the graph requested exists (sanity) */
if (!(db_fetch_cell("select local_graph_id from graph_templates_graph where local_graph_id=" . $_GET["local_graph_id"]))) {
	print "<strong><font size='+1' color='FF0000'>GRAPH DOES NOT EXIST</font></strong>"; exit;
}

/* take graph permissions into account here, if the user does not have permission
give an "access denied" message */
if (read_config_option("global_auth") == "on") {
	$access_denied = !(is_graph_allowed($_GET["local_graph_id"]));
	
	if ($access_denied == true) {
		print "<strong><font size='+1' color='FF0000'>ACCESS DENIED</font></strong>"; exit;
	}
}

$graph_param = ""; 

if (isset($_POST["start_year"]) and ($_POST["start_year"]!="")) {
        $start_year = $_POST["start_year"];
        $start_month = $_POST["start_month"];
        $start_day = $_POST["start_day"];
        $start_hour = $_POST["start_hour"];
        $start_min = $_POST["start_min"];
        $start_sec = $_POST["start_sec"];
        $end_year = $_POST["end_year"];
        $end_month = $_POST["end_month"];
        $end_day = $_POST["end_day"];
        $end_hour = $_POST["end_hour"];
        $end_min = $_POST["end_min"];
        $end_sec = $_POST["end_sec"];
        $graph_height = $_POST["graph_height"];
        $graph_width = $_POST["graph_width"];
}
else { 
	$end_now=strtotime("now");
	$begin_yesterday=strtotime("-1 day");
        $start_year = date("Y",$begin_yesterday); 
        $start_month = date("m",$begin_yesterday); 
        $start_day = date("d",$begin_yesterday); 
        $start_hour = date("H",$begin_yesterday); 
        $start_min = date("i",$begin_yesterday); 
        $start_sec = date("s",$begin_yesterday); 
        $end_year = date("Y",$end_now); 
        $end_month = date("m",$end_now); 
        $end_day = date("d",$end_now); 
        $end_hour = date("H",$end_now); 
        $end_min = date("i",$end_now); 
        $end_sec = date("s",$end_now); 
        $graph_height = 192; 
        $graph_width = 800; 
}
/*
if (isset($_POST["start_year"]) and ($_POST["start_year"]!="")) { 
        $graph_param .= "&graph_start=".mktime($_POST["start_hour"], $_POST["start_min"], $_POST["start_sec"], $_POST["start_month"], $_POST["start_day"], $_POST["start_year"])."&graph_end=".mktime($_POST["end_hour"], $_POST["end_min"], $_POST["end_sec"], $_POST["end_month"], $_POST["end_day"], $_POST["end_year"])."&graph_height=".$_POST["graph_height"]."&graph_width=".$_POST["graph_width"]; 
} 
else { 
        $start_year = date("Y"); 
        $start_month = date("m"); 
        $start_day = date("d", strtotime("-1 day")); 
        $start_hour = date("H"); 
        $start_min = date("i"); 
        $start_sec = date("s"); 
        $end_year = date("Y"); 
        $end_month = date("m"); 
        $end_day = date("d"); 
        $end_hour = date("H"); 
        $end_min = date("i"); 
        $end_sec = date("s"); 
        $graph_height = 192; 
        $graph_width = 800; 
}
*/

//$graph_param .= "&graph_start=".mktime($start_hour, $start_min, $start_sec, $start_month, $start_day, $start_year)."&graph_end=".mktime($end_hour, $end_min, $end_sec, $end_month, $end_day, $end_year)."&graph_height=$graph_height"."&graph_width=$graph_width"; 

$graph_end=mktime($end_hour, $end_min, $end_sec, $end_month, $end_day, $end_year);
//$graph_start=mktime($start_hour, $start_min, $start_sec, $start_month, $start_day, $start_year) - $graph_end;
$graph_start=$graph_end-mktime($start_hour, $start_min, $start_sec, $start_month, $start_day, $start_year);

$graph_param .= "&graph_start=-$graph_start&graph_end=$graph_end&graph_height=$graph_height"."&graph_width=$graph_width"; 
#print "start : $graph_start<br>end : $graph_end<br>param : $graph_param";

$graph_title = get_graph_title($_GET["local_graph_id"]);

if ((isset($_GET["type"]) ? $_GET["type"] : "") == "tree") {
	print "<table width='98%' style='background-color: #ffffff; border: 1px solid #ffffff;' align='center' cellpadding='3'>";
}else{
	print "<br><table width='98%' style='background-color: #f5f5f5; border: 1px solid #bbbbbb;' align='center' cellpadding='3'>";
}

print "<tr bgcolor='#" . $colors["header_panel"] . "'><td colspan='3' class='textHeaderDark'><strong>Viewing Graph</strong> '$graph_title'</td></tr>";

print "<tr><td>";

print "	<div align='center'><img src='graph_image.php?local_graph_id=" . $_GET["local_graph_id"] . "&rra_id=" . $_GET["rra_id"]. $graph_param . "' border='0' alt='$graph_title'></div>\n";

print "</td></tr>";

print "</table>";
print "<br><br>";

print "<table width='98%' style='background-color: #f5f5f5; border: 1px solid #bbbbbb;' align='center' cellpadding='3'>"; 
   print "<tr bgcolor='#" . $colors["header"] . "'><td colspan='3' class='textHeaderDark'><strong>Zoom parameters</strong></td></tr>"; 
   print "<tr><td>"; 

   print "<form method='post'>"; 
        start_box("Start graph at", "100%", $colors["header_panel"],"3", "center",""); 
        print "<tr><td><select name='start_year'>"; 
        for ($i=$start_year-2 ; $i<=$end_year+2 ; $i++) 
        { 
                ?><option value="<?print $i;?>"<?if ($i==$start_year) {?> selected<?}?>><?printf("%04d", $i);?></option> 
<?      } 
        print "</select> / "; 
        print "<select name='start_month'>"; 

        for ($i=1 ; $i<=12 ; $i++) 
        { 
                ?> <option value="<?print $i;?>"<?if ($i==$start_month) {?> selected<?}?>><?print date("M", mktime($start_hour, $start_min, $start_sec, $i, $start_day, $start_year));?></option> 
<?      } 
        print "</select> / "; 
        print "<select name='start_day'>"; 

        for ($i=1 ; $i<=31 ; $i++) 
        { 
                ?><option value="<?print $i;?>"<?if ($i==$start_day) {?> selected<?}?>><?printf("%02d", $i);?></option> 

<?      } 
        print "</select> at "; 
        print "<select name='start_hour'>"; 

        for ($i=0 ; $i<=23 ; $i++) 
        { 
                ?><option value="<?print $i;?>"<?if ($i==$start_hour) {?> selected<?}?>><?printf("%02d", $i);?></option> 

<?      } 
        print "</select> H "; 
        print "<select name='start_min'>"; 

        for ($i=0 ; $i<=59 ; $i++) 
        { 
                ?><option value="<?print $i;?>"<?if ($i==$start_min) {?> selected<?}?>><?printf("%02d", $i);?></option> 
<?      } 
        print "</select> m "; 
        print "<select name='start_sec'>"; 

        for ($i=0 ; $i<=59 ; $i++) 
        { 
                ?><option value="<?print $i;?>"<?if ($i==$start_sec) {?> selected<?}?>><?printf("%02d", $i);?></option> 
<?      } 
        print "</select> sec"; 
        print "</td></tr>"; 

   end_box(); 

        start_box("End graph at", "100%", $colors["header_panel"],"3", "center",""); 
        print "<tr><td><select name='end_year'>"; 

        for ($i=$start_year-2 ; $i<=$end_year+2 ; $i++) 
        { 
                ?><option value="<?print $i;?>"<?if ($i==$end_year) {?> selected<?}?>><?printf("%04d", $i);?></option> 
<?      } 
        print "</select> / "; 
        print "<select name='end_month'>"; 

        for ($i=1 ; $i<=12 ; $i++) 
        { 
                ?><option value="<?print $i;?>"<?if ($i==$end_month) {?> selected<?}?>><?print date("M", mktime($end_hour, $end_min, $end_sec, $i, $end_day, $end_year));?></option> 
<?      } 
        print "</select> / "; 
        print "<select name='end_day'>"; 

        for ($i=1 ; $i<=31 ; $i++) 
        { 
                ?><option value="<?print $i;?>"<?if ($i==$end_day) {?> selected<?}?>><?printf("%02d", $i);?></option> 
<?      } 
        print "</select> at "; 
        print "<select name='end_hour'>"; 

        for ($i=0 ; $i<=23 ; $i++) 
        { 
                ?><option value="<?print $i;?>"<?if ($i==$end_hour) {?> selected<?}?>><?printf("%02d", $i);?></option> 
<?      } 
        print "</select> H "; 
        print "<select name='end_min'>"; 

        for ($i=0 ; $i<=59 ; $i++) 
        { 
                ?><option value="<?print $i;?>"<?if ($i==$end_min) {?> selected<?}?>><?printf("%02d", $i);?></option> 
<?      } 
        print "</select> m "; 
        print "<select name='end_sec'>"; 

        for ($i=0 ; $i<=59 ; $i++) 
        { 
                ?><option value="<?print $i;?>"<?if ($i==$end_sec) {?> selected<?}?>><?printf("%02d", $i);?></option> 
<?      } 
        print "</select> sec"; 
        print "</td></tr>"; 
   end_box(); 

   start_box("Width", "100%", $colors["header_panel"],"3", "center",""); 
        print "<tr><td><input type='text' name='graph_width' size='20' value='" . $graph_width . "'></td></tr>"; 
   end_box(); 

   start_box("Height", "100%", $colors["header_panel"],"3", "center",""); 
        print "<tr><td><input type='text' name='graph_height' size='20' value='" . $graph_height . "'></td></tr>"; 
   end_box(); 
   print "<input type='image' src='images/button_view.gif' alt='Go' border='0' align='absm iddle' action='submit'>"; 
   print "</td></tr>"; 
   print "</table>";    
   print "</form>"; 

include_once("./include/bottom_footer.php");

?>
